diff --git a/base/deploy/src/scriptlets/webserver_layout.py b/base/deploy/src/scriptlets/webserver_layout.py
new file mode 100644
index 0000000..69ab059
--- /dev/null
+++ b/base/deploy/src/scriptlets/webserver_layout.py
@@ -0,0 +1,135 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2011 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    # instance-based webserver base
+    pki_instance_path = config.pki_root_prefix +\
+                        config.pki_master_dict['pki_instance_root'] + "/" +\
+                        config.pki_master_dict['pki_instance_name']
+
+    # instance-based webserver Apache base
+    pki_apache_path = pki_instance_path + "/" + config.PKI_APACHE
+
+    # instance-based webserver Tomcat base
+    pki_tomcat_path = pki_instance_path + "/" + config.PKI_TOMCAT
+    pki_common_path = pki_tomcat_path + "/" + config.PKI_COMMON_DIR
+    pki_common_lib_path = pki_common_path + "/" + config.PKI_LIB_DIR
+    pki_conf_path = pki_tomcat_path + "/" + config.PKI_CONF_DIR
+    pki_webapps_path = pki_tomcat_path + "/" + config.PKI_WEBAPPS_DIR
+    pki_webapps_root_path = pki_tomcat_path + "/" +\
+                            config.PKI_WEBAPPS_ROOT_DIR
+    pki_webapps_root_webinf_path = pki_tomcat_path + "/" +\
+                                   config.PKI_WEBAPPS_ROOT_WEBINF_DIR
+    pki_webapps_webinf_path = pki_tomcat_path + "/" +\
+                              config.PKI_WEBAPPS_WEBINF_DIR
+    pki_webapps_webinf_classes_path = pki_tomcat_path + "/" +\
+                                      config.PKI_WEBAPPS_WEBINF_CLASSES_DIR
+    pki_webapps_webinf_lib_path = pki_tomcat_path + "/" +\
+                                  config.PKI_WEBAPPS_WEBINF_LIB_DIR
+
+    # instance-based webserver configuration
+    pki_instance_configuration_path = config.pki_root_prefix +\
+        config.pki_master_dict['pki_instance_configuration_root'] + "/" +\
+        config.pki_master_dict['pki_instance_name']
+    pki_alias_configuration_path = pki_instance_configuration_path + "/" +\
+                                   config.PKI_SECURITY_DATABASE_DIR
+
+    def spawn(self):
+        config.pki_log.info(log.WEBSERVER_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish instance-based webserver base
+        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+            util.directory.create(self.pki_apache_path)
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            util.directory.create(self.pki_tomcat_path)
+            util.directory.create(self.pki_common_path)
+            util.directory.create(self.pki_common_lib_path)
+            util.directory.create(self.pki_conf_path)
+            util.directory.create(self.pki_webapps_path)
+            util.directory.create(self.pki_webapps_root_path)
+            util.directory.create(self.pki_webapps_root_webinf_path)
+            util.directory.create(self.pki_webapps_webinf_path)
+            util.directory.create(self.pki_webapps_webinf_classes_path)
+            util.directory.create(self.pki_webapps_webinf_lib_path)
+        # establish instance-based webserver configuration
+        util.directory.create(self.pki_alias_configuration_path)
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.WEBSERVER_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # update instance-based webserver base
+        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+            util.directory.modify(self.pki_apache_path)
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            util.directory.modify(self.pki_tomcat_path)
+            util.directory.modify(self.pki_common_path)
+            util.directory.modify(self.pki_common_lib_path)
+            util.directory.modify(self.pki_conf_path)
+            util.directory.modify(self.pki_webapps_path)
+            util.directory.modify(self.pki_webapps_root_path)
+            util.directory.modify(self.pki_webapps_root_webinf_path)
+            util.directory.modify(self.pki_webapps_webinf_path)
+            util.directory.modify(self.pki_webapps_webinf_classes_path)
+            util.directory.modify(self.pki_webapps_webinf_lib_path)
+        # update instance-based webserver configuration
+        util.directory.modify(self.pki_alias_configuration_path)
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.WEBSERVER_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # remove instance-based webserver base
+        if not config.pki_dry_run_flag and\
+           config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS and\
+           util.instance.apache_instances(self.pki_instance_path) == 0:
+            util.directory.delete(self.pki_apache_path)
+        elif config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS and\
+             util.instance.apache_instances(self.pki_instance_path) == 1:
+            # always display correct information (even during dry_run)
+            util.directory.delete(self.pki_apache_path)
+        if not config.pki_dry_run_flag and\
+           config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS and\
+           util.instance.tomcat_instances(self.pki_instance_path) == 0:
+            util.directory.delete(self.pki_tomcat_path)
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS and\
+             util.instance.tomcat_instances(self.pki_instance_path) == 1:
+            # always display correct information (even during dry_run)
+            util.directory.delete(self.pki_tomcat_path)
+        # remove instance-based webserver configuration
+        if not config.pki_dry_run_flag and\
+           util.instance.pki_subsystem_instances(self.pki_instance_path) == 0:
+            util.directory.delete(self.pki_alias_configuration_path)
+        elif util.instance.pki_subsystem_instances(self.pki_instance_path) == 1:
+            # always display correct information (even during dry_run)
+            util.directory.delete(self.pki_alias_configuration_path)
+        return self.rv
+
-- 
1.7.7.6

